<?php
/**
 * Created by IntelliJ IDEA.
 * User: xiexuanhua
 * Date: 2019/3/5
 * Time: 17:07
 */

class DhpayCheckout extends Model
{
    public function init($data){
        $form_data = $data['form'];
        $paymentMethodNonce = $data['paymentMethodNonce'];
        $ClientId = DHPAY_MERCHANT_ID;
        $Secret =   DHPAY_PRIVATE_KEY;
        echo $this->checkouts($form_data, $paymentMethodNonce, $ClientId, $Secret);
    }
    function checkouts($form_data, $paymentMethodNonce, $ClientId, $Secret)
    {
        if (empty($paymentMethodNonce) || empty($form_data)) {
            return json_encode(array('success' => false, 'data' => array("failure_reason" => "params miss.")));
        }

        $head = "Accept:application/json\r\n" .
            "Content-type:application/json\r\n" .
            "Accept-Charset:utf-8\r\n" .
            "Client-Id:" . $ClientId . "\r\n" .
            "Secret:" . $Secret;

        $opts = array(
            'http' => array(
                'method' => 'POST',
                'header' => $head,
                "content" => ""
            )
        );
        $context = stream_context_create($opts);
        $html = file_get_contents($this->getURL("oauth",""), false, $context);

        $access_token_resp = json_decode($html);
        $status = $access_token_resp->status;
        if ($status != '01') {
            return json_encode(array('success' => false, 'data' => array("failure_reason" => "get access ".$this->getURL("oauth","")." status:".$status)));
        } else {
            $access_token = $access_token_resp->data->access_token;
            $head =
                "Content-type:application/json\r\n" .
                "Accept-Charset:utf-8\r\n" .
                "Authorization:" . $access_token_resp->data->token_type . " " . $access_token . "\r\n";
            $request_param = $this->getRequestParam($form_data);
            $param = array(
                "requestParam" => $request_param,
                "cardParam" => array("tokenInfo" => $paymentMethodNonce)
            );

            $opts = array(
                'http' => array(
                    'method' => 'POST',
                    'header' => $head,
                    'timeout' => 25, //25s
                    "content" => json_encode($param)
                )
            );
            $context = stream_context_create($opts);
            $payment_resp = file_get_contents($this->getURL("payment",""), false, $context);
            if (!isset($payment_resp)) {//overtime query
                $payment_resp = $this->queryResponse($request_param["invoice_id"], $ClientId, $Secret);
            }
            return $this->handResponse($payment_resp);
        }
    }

    function queryResponse($invoid_id, $ClientId, $Secret)
    {
        $head =
            "Content-type:application/json\r\n" .
            "Accept-Charset:utf-8\r\n" .
            "Authorization:" . "Basic " . base64_encode($ClientId . ':' . $Secret);
        $opts = array(
            'http' => array(
                'method' => 'GET',
                'header' => $head,
                "content" => ""
            )
        );
        $context = stream_context_create($opts);
        $payment_resp = json_decode(file_get_contents($this->getURL("query",$invoid_id), false, $context));
        if (isset($payment_resp)) {
            //check the merchant and hash
            if ($ClientId == $payment_resp->merchant_id) {
                if ($this->checkSign($Secret,$payment_resp)) {
                    $resp = Array("status" => "01", "data" => $payment_resp);
                    return json_encode($resp);
                }
            }
        }
    }
    function getURL($fun,$param){
        $host="https://cashier.camelfin.com";
        if($fun=="payment"){
            $host=$host."/api/payments/nonce/v1";
        }
        else if($fun=="oauth"){
            $host=$host."/api/oauth2/token";
        }
        else if($fun=="query"){
            $host=$host."/merchant/api/query/".$param;
        }
        if('Test'==DHPAY_MODE){
            $host=$host."?env=dhpaysandbox";
        }
        return $host;
    }
    function checkSign($Secret,$kvs){
        $hash_src='';
        if(!is_array($kvs)){
            $kvs=json_decode(json_encode($kvs), true);
        }
        $hash_key=array_keys($kvs);
        sort($hash_key);
        foreach ($hash_key as $key) {
            if (($kvs['status'] == '01' && $key == 'failure_reason') || $key == 'hash'||$key=='description') {
                continue;
            }
            $hash_src =$hash_src. $kvs[$key];
        }
        $hash_src = $Secret . $hash_src;
        $hash = hash('sha256', $hash_src);
        if (strtoupper($hash) == $kvs['hash']){
            return true;
        }else
            return false;
    }

    function handResponse($payment_resp)
    {
        $resp = json_decode($payment_resp, false);
        if ($resp->status == '01') {
            if ($resp->data->status == '01') {
                $resp->success = true;
            } else if ($resp->data->status == '00') { //handle 3d submit
                $resp->success = true;
                $threeD = '<form id="form3D" action="' . $resp->data->redirect_url . '" method="POST">'
                    . '<input type="hidden" name="MD" value ="' . $resp->data->MD . '"/>'
                    . '<input type="hidden" name="paReq" value ="' . $resp->data->paReq . '"/>'
                    . '<input type="hidden" name="TermUrl" value ="' . $resp->data->TermUrl . '"/>'
                    . '<input type="hidden" name="orderId" value ="' . $resp->data->orderId . '"/>'
                    . '<input type="hidden" name="transactionId" value ="' . $resp->data->transactionId . '"/>'
                    . '<input type="hidden" name="sessionToken" value ="' . $resp->data->sessionToken . '"/>'
                    . '<input type="submit" class="btn" name="3D" value ="3D Payment submit"/></form>';
                $resp->form3D = $threeD;
            } else {
                $resp->success = false;
            }
        } else {
            return json_encode(array("success" => false, "data" => array("failure_reason" => "payment get fail response status:" . $resp->status . " " . $resp->error_code)));
        }
        return json_encode($resp);
    }

    function getRequestParam($param)
    {
        $result = array();
        $param=str_replace("&amp;", "&", $param);
        parse_str($param, $result);
        return $result;
    }

}